
//========================================================

class Media extends Div {

//========================================================

    //----------------------------------------------------
    onSetup(data){
    //----------------------------------------------------

        super.onSetup(data);
        this.add_variable("url",null);
    }
    //----------------------------------------------------

    onDraw(div,selected){

    //----------------------------------------------------
        div=super.onDraw(div,selected);
        //console.log(this.get_url(selected));
        return this.onDrawElement(div,selected);
   }
    //----------------------------------------------------

    onDrawElement(div,selected){

    //----------------------------------------------------

        return div;
   }

    //----------------------------------------------------
}
//========================================================

class BdImage extends Media {

//========================================================

    //----------------------------------------------------

    onDrawElement(div,selected){

    //----------------------------------------------------

        var img=jQuery('<img/>',{class:"w3-image",src:this.get_url(selected)});
        img.appendTo(div);
        return img;

   }
    //----------------------------------------------------
}
//========================================================

class Video extends Media {

//========================================================

    //----------------------------------------------------

    onDrawElement(div,selected){

    //----------------------------------------------------
        console.log(this.get_url(selected));
        var content=jQuery('<video controls/>',{style:"width:100%;height:auto;"});
        content.appendTo(div);
        var img=jQuery('<source/>',{src:this.get_url(selected)});
        img.appendTo(content);
        return img;

   }
    //----------------------------------------------------
}

//========================================================

class Audio extends Media {

//========================================================

    //----------------------------------------------------

    onDrawElement(div,selected){

    //----------------------------------------------------

        var img=jQuery('<audio controls/>',{src:this.get_url(selected)});
        img.appendTo(div);
        var elt=jQuery('<source/>',{src:this.get_url(selected)});
        elt.appendTo(img);
        return img;

   }
    //----------------------------------------------------
}

//========================================================

class DirectLink extends Media {

//========================================================

    //----------------------------------------------------

    onDrawElement(div,selected){

    //----------------------------------------------------

        //
        var img=jQuery('<a href="'+this.get_url(selected)+'"></a>',{});
        img.appendTo(div);
        return img;

   }
    //----------------------------------------------------
}
//========================================================

class Iframe extends Media {

//========================================================

    //----------------------------------------------------

    onDrawElement(div,selected){

    //----------------------------------------------------

        //
        var img=jQuery('<iframe src="'+this.get_url(selected)+'" style="width:100%;height:80vh;"></iframe>',{});
        img.appendTo(div);
        return img;

   }
    //----------------------------------------------------
}
//========================================================

class HtmlPage extends Media {

//========================================================

    //----------------------------------------------------

    onDrawElement(div,selected){

    //----------------------------------------------------

        var data=jQuery('<div/>');
        data.load(this.get_url(selected),this.onLoadFile.bind(this));
        data.appendTo(div);
        return data;
    }
    //----------------------------------------------------

    onLoadFile(data){

    //----------------------------------------------------



    }
    //----------------------------------------------------

}
//========================================================

class Request extends Media {

//========================================================
    //----------------------------------------------------
    onDraw(div,selected){
    //----------------------------------------------------
        this.div=div;
        new Query(this,this.get_url(selected),this.onFileLoaded.bind(this),"json");
    }
    //----------------------------------------------------
    onFileLoaded(data){
    //----------------------------------------------------

        console.log(data);

    }
    //----------------------------------------------------

}
//========================================================



